package dev.shadowsoffire.apotheosis.garden;

import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraft.ChatFormatting;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.network.chat.Component;
import java.util.List;
import net.minecraft.world.level.Level;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.item.context.UseOnContext;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import net.minecraft.world.entity.animal.Animal;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;

public class EnderLeadItem extends Item
{
    public EnderLeadItem() {
        super(new Item.Properties().m_41487_(1).m_41503_(15));
    }
    
    public boolean m_8120_(final ItemStack stack) {
        return false;
    }
    
    public boolean onLeftClickEntity(final ItemStack stack, final Player player, final Entity entity) {
        if (stack.m_41698_("entity_data").m_128456_() && entity instanceof Animal) {
            final CompoundTag tag = entity.serializeNBT();
            if (!player.m_9236_().f_46443_) {
                entity.m_146870_();
                stack.m_41783_().m_128365_("entity_data", (Tag)tag);
                stack.m_41783_().m_128359_("name", entity.m_5446_().getString());
                this.playSound(player);
            }
            return true;
        }
        return super.onLeftClickEntity(stack, player, entity);
    }
    
    public InteractionResult m_6225_(final UseOnContext ctx) {
        final CompoundTag tag = ctx.m_43722_().m_41698_("entity_data");
        if (!tag.m_128456_()) {
            final BlockPos pos = ctx.m_8083_().m_121945_(ctx.m_43719_());
            if (!ctx.m_43725_().f_46443_) {
                final Entity e = EntityType.m_20645_(tag, ctx.m_43725_(), a -> a);
                if (e != null) {
                    e.m_6034_(pos.m_123341_() + 0.5, pos.m_123342_() + 0.5, pos.m_123343_() + 0.5);
                    ctx.m_43725_().m_7967_(e);
                    ctx.m_43722_().m_41783_().m_128473_("entity_data");
                    this.playSound(ctx.m_43723_());
                    ctx.m_43722_().m_41622_(1, (LivingEntity)ctx.m_43723_(), pl -> pl.m_21190_(ctx.m_43724_()));
                    return InteractionResult.SUCCESS;
                }
            }
        }
        return InteractionResult.FAIL;
    }
    
    public CompoundTag getShareTag(final ItemStack stack) {
        CompoundTag tag = super.getShareTag(stack);
        if (tag == null) {
            return null;
        }
        tag = tag.m_6426_();
        final CompoundTag entity = new CompoundTag();
        if (tag.m_128469_("entity_data").m_128441_("id")) {
            entity.m_128359_("id", tag.m_128469_("entity_data").m_128461_("id"));
        }
        tag.m_128365_("entity_data", (Tag)entity);
        return tag;
    }
    
    void playSound(final Player player) {
        player.m_9236_().m_5594_((Player)null, player.m_20183_(), SoundEvents.f_11852_, SoundSource.AMBIENT, 1.0f, 1.0f);
    }
    
    @OnlyIn(Dist.CLIENT)
    public void m_7373_(final ItemStack stack, final Level worldIn, final List<Component> tooltip, final TooltipFlag flagIn) {
        if (stack.m_41782_()) {
            final CompoundTag tag = stack.m_41698_("entity_data");
            if (tag.m_128456_()) {
                tooltip.add((Component)Component.m_237115_("info.apotheosis.noentity").m_130940_(ChatFormatting.GRAY));
            }
            else {
                tooltip.add((Component)Component.m_237110_("info.apotheosis.containedentity", new Object[] { stack.m_41783_().m_128461_("name") }).m_130940_(ChatFormatting.GRAY));
            }
        }
    }
    
    public boolean m_5812_(final ItemStack stack) {
        return stack.m_41782_() && !stack.m_41698_("entity_data").m_128456_();
    }
}
